'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babelPluginSyntaxDynamicImport = require('babel-plugin-syntax-dynamic-import');

var _babelPluginSyntaxDynamicImport2 = _interopRequireDefault(_babelPluginSyntaxDynamicImport);

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function buildPromiseHandler() {
  return t.functionExpression(undefined, [], t.blockStatement([t.returnStatement(t.callExpression(t.identifier('require'), [t.identifier('modulePath')]))]));
}

function buildRequireAsync(scope, id) {
  const decl = t.functionExpression(t.identifier('requireAsync'), [t.identifier('modulePath')], t.blockStatement([t.returnStatement(t.callExpression(t.memberExpression(t.callExpression(t.memberExpression(t.identifier('Promise'), t.identifier('resolve')), []), t.identifier('then')), [buildPromiseHandler()]))]));

  scope.push({
    id,
    init: decl
  });
}

exports.default = function () {
  return {
    inherits: _babelPluginSyntaxDynamicImport2.default,
    name: 'import-node',
    visitor: {
      CallExpression(path, state) {
        if (path.node.callee.type === 'Import') {
          if (!state.file.requireAsyncIdentityForImportDynamic) {
            /* eslint-disable no-param-reassign */
            state.file.requireAsyncIdentityForImportDynamic = state.file.scope.generateUidIdentifier('requireAsync');
            /* eslint-enable no-param-reassign */
            buildRequireAsync(state.file.scope, state.file.requireAsyncIdentityForImportDynamic);
          }

          path.replaceWith(t.callExpression(state.file.requireAsyncIdentityForImportDynamic, path.node.arguments));
        }
      }
    }
  };
};